#ifndef __I8259_H__
#define __I8259_H__

extern unsigned int cached_irq_mask;

#define __byte(x,y)             (((unsigned char *) &(y))[x])
#define cached_master_mask      (__byte(0, cached_irq_mask))
#define cached_slave_mask       (__byte(1, cached_irq_mask))


extern void remap_8259A_irq(u32 pic_master_irq_start_num, u32 pic_slave_irq_start_num );
extern void enable_8259A_irq(u32 irq);
extern void disable_8259A_irq(u32 irq);


#define PIC_MASTER_CMD          0x20
#define PIC_MASTER_IMR          0x21
#define PIC_SLAVE_CMD           0xa0
#define PIC_SLAVE_IMR           0xa1


#define ICW1 (u8)0x11
#define ICW4 (u8)0x01



#endif  /* __I8259_H__ */
