#ifndef _THREAD_H_
#define _THREAD_H_ 1

#include <console.h>
#include "../md.h"

/* The same constant should be defined in thread.inc */
#define THREAD_INFO_MAGIC_VALUE 0x74FB89CE

/* If this struct is changed, modify thread.inc also */
typedef struct thread_info_t {
	u32		magic;
	u32		cpu;
	u32		irq_depth;
	u32		irq_count;
} thread_info_t ;

/*
 * We have allocated thread_info_t onto bottom of stack
 * at entry32.o
 * Because stack size can't exceed 8KBs, we can get stack bottom using 
 */
static inline thread_info_t *current_thread_info(void)
{
	thread_info_t * ti;
	__asm__("andl %%esp,%0; ":"=r" (ti) : "0" (~8191UL));
#if defined(DEBUG)
	if ( ti->magic != THREAD_INFO_MAGIC_VALUE )
	{
		printk("Thread info magic is broken. broken value->%x\n", ti->magic);
		halt();
	}
#endif	
	return ti;
}

#define GET_THREAD_INFO(reg)	\
		movl $-8192, reg; 		\
		andl %esp, reg


#define thr_cpu_id() 		(current_thread_info()->cpu)
#define thr_irq_depth()		(current_thread_info()->irq_depth)
#define thr_irq_count()	 	(current_thread_info()->irq_count)

#define preempt_enable()
#define preempt_disable()


#endif
