#ifndef _INTR_H_
#define _INTR_H_ 1

#include <thread.h>
#include "atomic.h"

#define local_irq_disable()     __asm__ __volatile__("cli": : :"memory")
#define local_irq_enable()      __asm__ __volatile__("sti": : :"memory")


#define local_irq_save(x)       __asm__ __volatile__("pushfl ; popl %0 ; cli":"=g" (x): /* no input */ :"memory")
#define local_irq_restore(x)    { typecheck(unsigned long,x); __asm__ __volatile__("pushl %0 ; popfl": /* no output */ :"g" (x):"memory", "cc"); }


#define irq_enter()   					\
{										\
	thr_irq_count() ++ 	;				\
	thr_irq_depth() ++ 	;				\
}

#define irq_exit()           			\
{  										\
	thr_irq_depth() -- ;				\
}

/*
	if ( thr_irq_count() == 0 )			\
	{									\
		if ( has_pending_soft_irq() )	\
		{								\
			do_softirq();				\
		}								\
	}									\
}
*/

extern atomic_t irq_err_count;

#define OS_INTR_VECTOR_BASE (0x30)

#define LOCAL_TIMER_VECTOR 		( 0x30 )
#define ERROR_APIC_VECTOR		( 0x31 )
#define SPURIOUS_APIC_VECTOR	( 0x3F )

#endif /* _INTR_H_ */
