/*
 * Machine dependent access functions for RTC registers.
 */
#ifndef _ASM_MC146818RTC_H
#define _ASM_MC146818RTC_H

#include "md.h"

#ifndef RTC_PORT
#define RTC_PORT(x)	(0x70 + (x))
#define RTC_ALWAYS_BCD	1	/* RTC operates in binary mode */
#endif

/*
 * The yet supported machines all access the RTC index register via
 * an ISA port access but the way to access the date register differs ...
 */
#define CMOS_READ(addr) ({ \
md_out(RTC_PORT(0),(addr)); \
md_in(RTC_PORT(1)); \
})
#define CMOS_WRITE(val, addr) ({ \
md_out(RTC_PORT(0),(addr)); \
md_out(RTC_PORT(1),(val)); \
})

#define RTC_IRQ 8

#endif /* _ASM_MC146818RTC_H */
