#ifndef _MD_H_
#define _MD_H_

void init_cpu_A20();
void test_cpu_A20();



#include "cpu.h"

typedef struct machine_t {
	cpu_info_t cpu[ MAX_CPUS ] ;
} machine_t ;

extern u32 cpu_count;

extern machine_t mach_;

#define boot_cpu_data ( mach_.cpu[0] )

#define cpu_has_apic     ( boot_cpu_data.caps & X86_CAP_APIC )
#define boot_cpu_apicid  ( boot_cpu_data.ebx.lapic_id )

#define virt_to_phys(x) (x)
#define phys_to_virt(x) (x)

static OS_INLINE u32 get_bios_ebda(void)
{
	u32 address = *(u16 *)phys_to_virt(0x40E);
	address <<= 4;
	return address; /* 0 means none */
}

OS_INLINE u8 	md_in	( u16 port );
OS_INLINE void 	md_out	( u16 port, u8 data );

#define KERNEL_CS (0x08)
#define KERNEL_DS (0x10)

#define asmlinkage __attribute__((regparm(0)))
#define FASTCALL(x) x __attribute__((regparm(3)))

#define barrier() __asm__ __volatile__("": : :"memory")

typedef struct md_spin_lock_t
{
	u32 lock;
}md_spin_lock_t;

#define MD_SPIN_UNLOCKED {0}

void md_spin_trylock	( md_spin_lock_t * lock );
void md_spin_lock		( md_spin_lock_t * lock ); 
void md_spin_unlock 	( md_spin_lock_t * lock );

extern void halt();

#endif /*_MD_H_*/
