#ifndef _MPSPEC_H
#define _MPSPEC_H

#include "mpspec_def.h"
#include "apic_def.h"

#define MAX_APICS 16
#define MAX_IRQ_SOURCES 256
#define MAX_MP_BUSSES 32
#define BAD_APICID 0xFFu

/* Have we found an MP table */
extern int smp_found_config;

/*
 * Various Linux-internal data structures created from the
 * MP-table.
 */
extern u8 apic_version [MAX_APICS];
extern int mp_bus_id_to_type [MAX_MP_BUSSES];
extern int mp_bus_id_to_pci_bus [MAX_MP_BUSSES];

extern int mp_current_pci_id;

// I/O APIC entries 
extern struct mpc_config_ioapic mp_ioapics[MAX_IO_APICS];

// # of MP IRQ source entries 
extern struct mpc_config_intsrc mp_irqs[MAX_IRQ_SOURCES];

extern int mp_irq_entries;

extern int nr_ioapics;

extern int pic_mode;

extern unsigned long mp_lapic_addr;

/* Processor that is doing the boot up */
extern unsigned int boot_cpu_physical_apicid;
extern unsigned int num_processors;

extern u8 bios_cpu_apicid[ MAX_CPUS ];



#define BITS_PER_LONG 32

#define BITS_TO_LONGS(bits) \
        (((bits)+BITS_PER_LONG-1)/BITS_PER_LONG)


#endif

