#ifndef _SMP_H_
#define _SMP_H_

#include "../md.h"

#define TRAMPOLINE_LOW phys_to_virt(0x467)
#define TRAMPOLINE_HIGH phys_to_virt(0x469)

static inline void smpboot_setup_warm_reset_vector(unsigned long start_eip)
{
        CMOS_WRITE(0xa, 0xf);
//        local_flush_tlb();

        *((volatile unsigned short *) TRAMPOLINE_HIGH) = start_eip >> 4;
        *((volatile unsigned short *) TRAMPOLINE_LOW) = start_eip & 0xf;
}

static inline void smpboot_restore_warm_reset_vector(void)
{
        /*
         * Install writable page 0 entry to set BIOS data area.
         */
//        local_flush_tlb();

        /*
         * Paranoid:  Set warm reset code and vector here back
         * to default values.
         */
        CMOS_WRITE(0, 0xf);

        *((volatile long *) phys_to_virt(0x467)) = 0;
}

/*
 * entry16 of entry16.o
 */
#define AP_STARTUP_EIP 0x8000

#endif /* _SMP_H_ */
